TYPE CFileReader
  AS STRING Tex, FNam
  DECLARE FUNCTION readCCom(BYVAL Mo AS INTEGER = 0) AS STRING
  DECLARE SUB readTo(BYREF S AS STRING)
  DECLARE SUB readLine(BYVAL Mo AS INTEGER = 0)
  DECLARE SUB newTex()
  DECLARE SUB newBlock()
  DECLARE FUNCTION Erro() AS ZSTRING PTR
  DECLARE FUNCTION weGo() AS INTEGER
  DECLARE FUNCTION Ende() AS INTEGER
  DECLARE FUNCTION LaCh() AS UBYTE
  DECLARE CONSTRUCTOR(BYREF F AS STRING)
  DECLARE DESTRUCTOR()

Private:
  DIM AS INTEGER Po, Le, Ca
  UNION
    AS UBYTE PTR Buff
    AS ZSTRING PTR CSOU
  END UNION
  DIM AS UBYTE Af
  DIM AS INTEGER Kl, Pa, En, CaBl, CeBl
END TYPE

CONSTRUCTOR CFileReader(BYREF F AS STRING)
  VAR fnr = FREEFILE, busi = 1024 ' Buff size for Geany mode
  IF LEN(F) THEN
    Po = OPEN (F FOR BINARY ACCESS READ LOCK WRITE AS #fnr) : IF Po THEN EXIT CONSTRUCTOR
    Le = LOF(fnr) : Po = -1
    Buff = ALLOCATE(Le + 1)
    IF Buff THEN
      GET #fnr, , *Buff, Le, En
      Buff[Le] = 0 : FNam = F : IF Le <> En THEN Le = - En
    ELSE
      Po = -2
    END IF
  ELSE
    Po = OPEN CONS (FOR INPUT AS #fnr) : IF Po THEN EXIT CONSTRUCTOR
    En = busi : Po = -1 : Buff = ALLOCATE(En)
    IF Buff THEN
      WHILE NOT EOF(fnr)
        GET #fnr, , Af : Buff[Le] = Af : Le += 1
        IF Le > En THEN
          En += busi : Buff = REALLOCATE(Buff, En)
          IF Buff = 0 THEN Po = -2 : EXIT WHILE
        END IF
      WEND : Buff[Le] = 0 : FNam = "root"
    ELSE
      Po = -2
    END IF
  END IF : CLOSE #fnr
END CONSTRUCTOR

DESTRUCTOR CFileReader : DEALLOCATE(Buff)
END DESTRUCTOR

FUNCTION CFileReader.weGo() AS INTEGER : RETURN Po < Le
END FUNCTION

FUNCTION CFileReader.Ende() AS INTEGER : RETURN Po >= Le
END FUNCTION

FUNCTION CFileReader.LaCh() AS UBYTE : RETURN Buff[Po]
END FUNCTION

SUB CFileReader.newTex() : Tex = "" : Ca = Po + 1
END SUB

SUB CFileReader.newBlock() : CaBl = Ca : CeBl = Po : Tex = ""
END SUB

FUNCTION CFileReader.Erro() AS ZSTRING PTR
  IF Le < 0 THEN RETURN @"File length <> bytes red: "
  IF Le = 0 THEN RETURN @"no input: "
  IF Po = -2 THEN RETURN @"out of memory: "
  IF Po = -1 THEN RETURN 0
  RETURN @"read error: "
END FUNCTION

' reads .h up to one of the characters S, counts ([{"''"}])
' liest bis zum naechsten Stop-Zeichen S, zaehlt Klammern
SUB CFileReader.readTo(BYREF S AS STRING)
  Po += 1 : IF Po < Le THEN Pa = Po : Af = 0 : Kl = 0 ELSE EXIT SUB
  VAR lf = 0
  DO
    IF Kl = 0 THEN IF Af = 0 THEN IF INSTR(S, CHR(Buff[Po])) THEN EXIT DO
    SELECT CASE AS CONST CHAR_TYP(Buff[Po])
    CASE 1 '                                ASC("("), ASC("{"), ASC("[")
      lf = 0 : IF Af = 0 THEN Kl += 1
    CASE 2 '                                ASC(")"), ASC("}"), ASC("]")
      lf = 0 : IF Af = 0 THEN Kl -= 1
    CASE 3 '                                         ASC("'"), ASC("""")
      lf = 0 : checkAf(Af, *CSOU, Po)
    CASE 4 '                                          ASC("/"), ASC("*")
      IF Af = 0 ANDALSO Buff[Po] = ASC("/") _
                ANDALSO Po < Le ANDALSO CHAR_TYP(Buff[Po + 1]) = 4 THEN
        Tex &= RTRIM(MID(*CSOU, Pa + 1, Po - Pa), TRIMM)
        Pa = Po + 2
        IF Buff[Po + 1] = ASC("*") THEN '       /* multi line comment */
          DO
            WHILE Pa < Le
              IF Buff[Pa] <> ASC("/") THEN Pa += 1 ELSE EXIT WHILE
            WEND : Pa += 1 : IF Buff[Pa - 2] = ASC("*") THEN EXIT DO
          LOOP
        ELSE '                                    // single line comment
          WHILE Pa < Le
            IF Buff[Pa] <> ASC(!"\n") THEN Pa += 1 ELSE EXIT WHILE
          WEND
        END IF : Po = Pa - 1
      END IF : lf = 0
    CASE 10
      Tex &= RTRIM(MID(*CSOU, Pa + 1, Po - Pa + 1), TRIMM) : Pa = Po
      IF LEN(Tex) THEN
        IF lf = 0 THEN lf = 1 ELSE IF Kl = 0 THEN IF Af = 0 THEN EXIT DO
      END IF
    CASE 12 '                                       ignore vertical tabs
    CASE CHAR_TYPE_END : EXIT DO
    CASE ELSE : lf = 0
    END SELECT : Po += 1
  LOOP UNTIL Po >= Le : Tex &= MID(*CSOU, Pa + 1, Po - Pa)
END SUB

' reads .h up to NL character
' liest und komprimiert PreCo Zeile (bis NL, \ wird berücksichtigt)
SUB CFileReader.readLine(BYVAL Mo AS INTEGER = 0)
  Po += 1 : IF Po < Le THEN Af = 0 : Pa = Po ELSE EXIT SUB
  DO
    SELECT CASE AS CONST CHAR_TYP(Buff[Po])
    CASE 4 '                                          ASC("/"), ASC("*")
      IF Af = 0 ANDALSO Buff[Po] = ASC("/") _
                ANDALSO Po < Le ANDALSO CHAR_TYP(Buff[Po + 1]) = 4 THEN
        Tex &=  MID(*CSOU, Pa + 1, Po - Pa)
        Pa = Po + 2
        IF Buff[Po + 1] = ASC("*") THEN '       /* multi line comment */
          DO
            WHILE Pa < Le
              IF Buff[Pa] <> ASC("/") THEN Pa += 1 ELSE EXIT WHILE
            WEND : Pa += 1 : IF Buff[Pa - 2] = ASC("*") THEN EXIT DO
          LOOP
        ELSE '                                    // single line comment
          IF Mo THEN Po -= 2 : EXIT SUB
          WHILE Pa < Le
            IF Buff[Pa] <> ASC(!"\n") THEN Pa += 1 ELSE EXIT WHILE
          WEND
        END IF : Po = Pa - 1
      END IF
    CASE 10 : Tex &= RTRIM(MID(*CSOU, Pa + 1, Po - Pa), TRIMM)
      Pa = Po : IF RIGHT(Tex, 1) <> "\" THEN EXIT SUB
    CASE CHAR_TYPE_END : EXIT DO
    END SELECT : Po += 1
  LOOP UNTIL Po >= Le : Tex &= MID(*CSOU, Pa + 1, Po - Pa)
END SUB

' reads .h comments from St (or Ca) to Po
' liest Kommentare von Ca (oder CaBl) bis Po
' Bit0: Start CaBl, end CeBl (default CA, Po)
' Bit1: End after first NL
' Bit2: C-comments
' Bit3: C-source
' Bit6: compress C-source
' Bit7: compress C-comments
FUNCTION CFileReader.readCCom(BYVAL Mo AS INTEGER = 0) AS STRING
  Ca = IIF((Mo AND &b01) = &b01, CaBl, Ca) : IF Ca < Po THEN Af = 0 : Pa = Ca ELSE RETURN ""
  VAR r = "", ee = Po
  IF BIT(Mo, 1) THEN Mo = BITRESET(Mo, 3)
  IF (Mo AND &b01100) = &b01100 THEN
    Ca = ee
  ELSE
    IF BIT(Mo, 0) THEN IF BIT(Mo, 3) = 0 THEN ee = CeBl
    WHILE Ca <= ee
      SELECT CASE AS CONST CHAR_TYP(Buff[Ca])
      CASE 3 '                                       ASC("'"), ASC("""")
        checkAf(Af, *CSOU, Ca)
      CASE 4 '                                        ASC("/"), ASC("*")
        IF Af = 0 ANDALSO Ca < Le ANDALSO _
          Buff[Ca] = ASC("/") ANDALSO CHAR_TYP(Buff[Ca + 1]) = 4 THEN
          IF BIT(Mo, 3) THEN r &= MID(*CSOU, Pa + 1, Ca - Pa)
          IF Buff[Ca + 1] = ASC("*") THEN '     /* multi line comment */
            IF BIT(Mo, 1) THEN Ca = Pa : RETURN ""
            Pa = Ca + 2
            DO
              WHILE Pa < ee
                IF Buff[Pa] <> ASC("/") THEN Pa += 1 ELSE EXIT WHILE
              WEND : Pa += 1 : IF Buff[Pa - 2] = ASC("*") THEN EXIT DO
            LOOP
            IF BIT(Mo, 3) = 0 THEN
              IF LEN(r) THEN IF RIGHT(r, 1) <> !"\n" THEN r &= NL
              r &= "/'" & MID(*CSOU, Ca + 3, Pa - Ca - 4) & "'/"
            END IF
          ELSE '                                  // single line comment
            Pa = Ca + 2
            WHILE Pa < ee
              IF Buff[Pa] <> ASC(!"\n") THEN Pa += 1 ELSE EXIT WHILE
            WEND
            IF BIT(Mo, 3) = 0 THEN
              IF LEN(r) = 0 THEN r = " "
              r &= "'" & MID(*CSOU, Ca + 3, Pa - Ca - 2)
              IF BIT(Mo, 1) THEN EXIT WHILE
            END IF
          END IF : Ca = Pa - 1
        END IF
      CASE 10 : IF BIT(Mo, 1) THEN Ca = Pa : RETURN ""
      END SELECT : Ca += 1
    WEND
    IF BIT(Mo, 3) = 0 THEN '                                     comment
      IF BIT(Mo, 7) THEN Kompri(r, -1)
      IF BIT(Mo, 1) THEN Ca = Pa
      RETURN r
    END IF
  END IF : r &= MID(*CSOU, Pa + 1, ee - Pa + 1) '               C source
  IF BIT(Mo, 6) THEN Kompri(r, -1)
  Ca = ee : RETURN genKom(r)
END FUNCTION
